Home | History | Annotate | Download | only in move
      1 #!/bin/bash
      2 
      3 #
      4 # Copyright (c) International Business Machines  Corp., 2005
      5 # Author: Avantika Mathur (mathurav (at] us.ibm.com)
      6 #
      7 # This library is free software; you can redistribute it and/or
      8 # modify it under the terms of the GNU Lesser General Public
      9 # License as published by the Free Software Foundation; either
     10 # version 2.1 of the License, or (at your option) any later version.
     11 #
     12 # This library is distributed in the hope that it will be useful,
     13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
     14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     15 # Lesser General Public License for more details.
     16 #
     17 # You should have received a copy of the GNU Lesser General Public
     18 # License along with this library; if not, write to the Free Software
     19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
     20 #
     21 
     22 SETS_DEFAULTS="${TCID=test08} ${TST_COUNT=1} ${TST_TOTAL=1}"
     23 declare -r TCID
     24 declare -r TST_COUNT
     25 declare -r TST_TOTAL
     26 export TCID TST_COUNT TST_TOTAL
     27 
     28 tst_resm TINFO "***************TEST08***************"
     29 tst_resm TINFO "move: private subtree to uncloneable parent."
     30 tst_resm TINFO "************************************"
     31 
     32 . "${FS_BIND_ROOT}/bin/setup" || (tst_resm TWARN "Setup of move/test08 failed" && tst_exit)
     33 export result=0
     34 
     35 
     36 
     37 trap 'ERR=$? ; ERR_MSG="caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"; break' ERR
     38 
     39 while /bin/true ; do
     40 	# This loop is for error recovery purposes only
     41 
     42 
     43 	"${FS_BIND_ROOT}/bin/makedir" priv dir
     44 	"${FS_BIND_ROOT}/bin/makedir" unclone parent2
     45 	"${FS_BIND_ROOT}/bin/makedir" share share1
     46 
     47 	mkdir dir/grandchild
     48 	mount --bind dir share1
     49 	mkdir parent2/child2
     50 	mount --move dir parent2/child2
     51 
     52 	mount --bind "$disk1" parent2/child2/grandchild
     53 	check -n dir/grandchild parent2/child2/grandchild
     54 	check -n share1/grandchild parent2/child2/grandchild
     55 
     56 	break
     57 done
     58 trap 'ERR=$? ; tst_resm TWARN "move/test08: caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"' ERR
     59 if [ -n "${ERR_MSG}" ]; then
     60 	tst_resm TWARN "move/test08: ${ERR_MSG}"
     61 	ERR_MSG=""
     62 	result=$ERR
     63 fi
     64 trap '' ERR
     65 {
     66 	umount parent2/child2/grandchild
     67 	umount parent2/child2 # if move succeeded
     68 	umount dir # if move failed
     69 	umount share1
     70 	umount share1
     71 	umount parent2
     72 	umount dir
     73 
     74 	rm -rf dir parent* share*
     75 	cleanup
     76 } >& /dev/null
     77 if [ $result -ne 0 ]
     78 then
     79 	tst_resm TFAIL "move/test08: FAILED: move: private subtree to uncloneable parent."
     80 	exit 1
     81 else
     82 	tst_resm TPASS "move/test08: PASSED"
     83 	exit 0
     84 fi
     85 tst_exit
     86